set(0,'DefaultLineLineWidth',3);
clf;
% dos cuerpos (uno fijo).

% MASAS
M = [500 100];
% posicion (coordenadas) iniciales
P = [0 0; ...
    50 0];

% velocidades iniciales: el primero quieto,
% si no, esta mal
V = [0 0; ...
    4.1 -4.1];

% constante de gravitacion universal
% ponemos un valor que sirva para que salga
% algo coherente (no importa)
g = 2;

%
% ecuacion diferencial
% x2'  = Vx2
% Vx2' = Fx2/M(2)
% 
% y2'  = Vy2
% Vy2' = Fy2/M(2)
% 
% necesitamos CUATRO componentes
f=@(t,X) [X(2); ...
          M(1)*g*(-X(1)/((X(1)-P(1,1))^2+(X(3)-P(1,2))^2)^(3/2)); ...
          X(4); ...
          M(1)*g*(-X(3)/((X(1)-P(1,1))^2+(X(3)-P(1,2))^2)^(3/2))];
 X0 = [P(2,1); ...
       P(2,2); ...
       V(2,1); ...
       V(2,2)]; 
 
% resolvemos con Heun: para este caso, un anyo es aprox.
% 825 unidades de tiempo. Dibujamos 10 anyos
% si se hila mas fino (p.ej. T=[0:.01:823*10], Euler va mejor
T = [0:.1:823*10]; 
Y = heunvector(f, T, X0);
YE = eulervector(f, T, X0);
plot(Y(1,:),Y(3,:),'b-');
hold on

% El otro punto de masa esta en un foco de la elipse
rectangle('Position',[-5 -5 10 10],'Curvature',[1 1],'FaceColor',[1 0 0]);
axis equal

% la "trajectoria" de Euler
plot(YE(1,:),YE(3,:),'k--','LineWidth',1);
disp('presiona')
pause
clf
rectangle('Position',[-5 -5 10 10],'Curvature',[1 1],'FaceColor',[1 0 0]);
axis equal
hold on
% poco a poco
for k=2:length(T)
    plot([Y(1,k-1),Y(1,k)],[Y(3,k-1),Y(3,k)],'b-');
    plot([YE(1,k-1),YE(1,k)],[YE(3,k-1),YE(3,k)],'k--','LineWidth',1);
    pause(1/30000);
end
