% para que se vea algo
set(0,'DefaultLineLineWidth',4);
clf;

%% Ejemplo 1 de minimos cuadrados lineales
% se nos da una nube que tiene apariencia periodica
% primero tratamos de escribirla como
% A + Bcos(x) + Csen(x)
%
% y desupes como
% A + Bcos(x) + Csen(x) + Dcos(2x) + Esen(2x)
%
% cambia mucho el error cuadratico
% y tambien cambian los coeficientes!!!!
%
t = [0:.01:10];


%% esta parte es solo para definir la nube (digamos que
%  no forma parte del enunciado: pero hay que ejecutarla
%  para tener la nube de puntos)
muestras = sort(10*rand(1,20));
% una nube mas o menos 
f = @(T) (-0.4+rand(size(T))*.1)+(2+rand(size(T))*.1).*sin(T) + ...
    (-1.2+rand(size(T))*.1).*cos(T) + ...
    (.3+rand(size(T))*.2).*sin(2*T) + ...
    (.7+rand(size(T))*.2).*cos(2*T);
% estos son los valores de la nube
y = f(muestras);
plot(muestras, y,'*');

%% primera aproximacion
% vamos a intentar aproximarla con una funcion co/senoidal ...
%   mas una constante
g1 = @(x) ones(size(x));
g2 = @(x) sin(x);
g3 = @(x) cos(x);

% seguimos las instrucciones
X = [g1(muestras); ...
     g2(muestras); ...
     g3(muestras)];

% hay que trasponer y para ponerlo "vertical"
Y = X * y';
A = X*X';

coefs = A\Y

% coefs contiene los 3 parametros
F = @(x) coefs(1)*g1(x) + coefs(2)*g2(x) + coefs(3)*g3(x);

disp('Error cuadratico');
e = sum((y-F(muestras)).^2)

hold on;
plot(t, F(t), 'r');
    
%% segunda aproximacion
% podemos hacerlo mejor?
% veamos con sen(t), cos(t) y sen(2t), cos(2t)
% como las otras ya estan definidas, solo anyado
g4 = @(x) sin(2*x);
g5 = @(x) cos(2*x);

X = [X;
     g4(muestras);
     g5(muestras)];
Y = X * y';
A = X*X';

coefs = A\Y
% OJO:
% NO PUEDO sumar la F anterior a los nuevos coeficientes
% porque han cambiado todos
F2 = @(x) coefs(1)*g1(x) + coefs(2)*g2(x) + ...
    coefs(3)*g3(x) + coefs(4)*g4(x) + coefs(5)*g5(x);
plot(t, F2(t));

disp('Error cuadratico');
e2 = sum((y-F2(muestras)).^2)

%% tercer intento:
% y si pongo mas frecuencias???
g6 = @(x) sin(3*x);
g7 = @(x) cos(3*x);

X = [X;
     g6(muestras);
     g7(muestras)];
Y = X * y';
A = X*X';

coefs = A\Y
F3 = @(x) coefs(1)*g1(x) + coefs(2)*g2(x) + ...
    coefs(3)*g3(x) + coefs(4)*g4(x) + coefs(5)*g5(x) + ...
    coefs(6)*g6(x) + coefs(7)*g7(x);
plot(t, F3(t));

disp('Error cuadratico');
e3 = sum((y-F3(muestras)).^2)
% practicamente NO HAY influencia de la frecuencia 3,
% como se ve en la grafica y en el poco cambio del error