% para que se vea algo
set(0,'DefaultLineLineWidth',4);
clf;

%% ENUNCIADO:
% unos expertos dicen que los valores de la posicion
% de un objeto al cabo de 1, 2, ..., 10 segundos son los
% que se dan en el vector s (metros).
% Afirman que:
%   1) El movimiento es rectilineo y uniformemente acelerado
%   2) La velocidad inicial es 0
% Segun ellos, las mediciones son muy precisas hasta
% los centimetros (por eso nos dan dos decimales) y
% el tiempo de medicion tambien.
% Nuestro trabajo es verificar si es razonable que la
% velocidad inicial sea 0, tal como ellos dicen.
t = [0:.01:10]; % solo para las graficas

% datos de medicion
T = [1:10];
s = [21.15 50.50 97.50 162.96 245.69 347.97 ...
     468.26 605.75 761.10 934.94];
plot(T,s,'*');

%% aproximacion con v0=0
% movimiento rectilineo uniformemente acelerado:
% s(t) = s0 + v0*t + a*t^2/2;
% pero me dicen que v0 es 0: no pongo el termino lineal
g1 = @(x) ones(size(x));
g2 = @(x) x.^2/2;

% X
X = [g1(T); ...
     g2(T)];

% Y
Y = X*s';

% A
A = X*X';

% coeficientes
coefs = A\Y
F = @(t) coefs(1) * g1(t) + coefs(2)*g2(t); 
hold on;
plot(t, F(t));

% error cuadratico total (sale 18.65...)
e = sum((s-F(T)).^2)

%% aproximacion con v0 distinto de 0
% a lo mejor me estan "colando" lo de que v0=0
% introducimos la componente lineal
g1 = @(x) ones(size(x));
g2 = @(x) x;
g3 = @(x) x.^2/2;

% X
X = [g1(T); ...
     g2(T); ...
     g3(T)];

% Y
Y = X*s';

% A
A = X*X';

% coeficientes
coefs = A\Y
F2 = @(t) coefs(1) * g1(t) + coefs(2)*g2(t) + ...
    coefs(3)*g3(t);
plot(t,F2(t));
e2 = sum((s-F2(T)).^2)


% e2 sale 1.1691... e era 18.65...
% e2 << e, parece que v0 no puede ser 0
%      sino mas bien alrededor de 2 (coefs(2))
% el modelo con velocidad inicial no nula explica mucho mejor
% los datos que con v0=0, asi que no es razonable suponer
% que v0=0 (si TODO LO DEMAS es verdad): podria ser que
% su cronometro fuera basura, o el metro, o tantas cosas...
%
% LAS GRAFICAS son casi iguales pero
% las graficas son solo dibujitos